From 68fba8e80c6233fd55f85046443bb945f62da071 Mon Sep 17 00:00:00 2001
From: Steve MacLean <sdmaclea.qdt@qualcommdatacenter.com>
Date: Mon, 4 Jun 2018 13:55:34 -0400
Subject: [PATCH] Use atomic ops in CommitGCStressInstructionUpdate()

---
 src/vm/threads.h         | 19 ++++++++++++++-----
 src/vm/threadsuspend.cpp | 20 ++++++++++++--------
 2 files changed, 26 insertions(+), 13 deletions(-)

diff --git a/src/vm/threads.h b/src/vm/threads.h
index 5cafc61..e73d7ce 100644
--- a/src/vm/threads.h
+++ b/src/vm/threads.h
@@ -4831,16 +4831,25 @@ public:
     {
         LIMITED_METHOD_CONTRACT;
         BYTE* dest = VolatileLoad(&m_pbDestCode);
-        CONSISTENCY_CHECK((NULL == dest) || (NULL != VolatileLoadWithoutBarrier(&m_pbSrcCode)));
         return dest != NULL;
     }
-    void ClearGCStressInstructionUpdate()
+    bool TryClearGCStressInstructionUpdate(BYTE** ppbDestCode, BYTE** ppbSrcCode)
     {
         LIMITED_METHOD_CONTRACT;
-        PRECONDITION(HasPendingGCStressInstructionUpdate());
+        bool result = false;
 
-        VolatileStoreWithoutBarrier<BYTE*>(&m_pbDestCode, NULL);
-        VolatileStore<BYTE*>(&m_pbSrcCode, NULL);
+        if(HasPendingGCStressInstructionUpdate())
+        {
+            *ppbDestCode = FastInterlockExchangePointer(&m_pbDestCode, NULL);
+
+            if(*ppbDestCode != NULL)
+            {
+                result = true;
+                *ppbSrcCode = FastInterlockExchangePointer(&m_pbSrcCode, NULL);
+
+                CONSISTENCY_CHECK(*ppbSrcCode != NULL);
+            }
+        }
     }
 #if defined(GCCOVER_TOLERATE_SPURIOUS_AV)
     void SetLastAVAddress(LPVOID address)
diff --git a/src/vm/threadsuspend.cpp b/src/vm/threadsuspend.cpp
index 65a3841..074af96 100644
--- a/src/vm/threadsuspend.cpp
+++ b/src/vm/threadsuspend.cpp
@@ -5050,30 +5050,34 @@ void Thread::CommitGCStressInstructionUpdate()
     }
     CONTRACTL_END;
 
-    if (HasPendingGCStressInstructionUpdate())
+    BYTE* pbDestCode = NULL;
+    BYTE* pbSrcCode = NULL;
+
+    if (TryClearGCStressInstructionUpdate(&pbDestCode, &pbSrcCode))
     {
+        assert(pbDestCode != NULL);
+        assert(pbSrcCode != NULL);
+
 #if defined(_TARGET_X86_) || defined(_TARGET_AMD64_)
 
-        *m_pbDestCode = *m_pbSrcCode;
+        *pbDestCode = *pbSrcCode;
 
 #elif defined(_TARGET_ARM_)
 
         if (GetARMInstructionLength(m_pbDestCode) == 2)
-            *(WORD*)m_pbDestCode  = *(WORD*)m_pbSrcCode;
+            *(WORD*)pbDestCode  = *(WORD*)pbSrcCode;
         else
-            *(DWORD*)m_pbDestCode = *(DWORD*)m_pbSrcCode;
+            *(DWORD*)pbDestCode = *(DWORD*)pbSrcCode;
 
 #elif defined(_TARGET_ARM64_)
 
-        *(DWORD*)m_pbDestCode = *(DWORD*)m_pbSrcCode;
+        *(DWORD*)pbDestCode = *(DWORD*)pbSrcCode;
 
 #else
 
-        *m_pbDestCode = *m_pbSrcCode;
+        *pbDestCode = *pbSrcCode;
 
 #endif
-
-        ClearGCStressInstructionUpdate();
     }
 }
 
-- 
2.7.4

